/*
 * AutoFrame.java
 *
 * Created on 17 de noviembre de 2005, 0:03
 */

package Auto;
import java.awt.*;

import com.threed.jpct.*;
import com.threed.jpct.util.*;
import org.lwjgl.opengl.*;
import java.io.*;
/**
 *
 * @author  Gold Oozaru
 */
public class AutoFrame extends javax.swing.JFrame {

    World mundo;
    Camera camara;
    FrameBuffer buffer;
    Texture colores [];
    KeyMapper mapaTeclas;

    Canvas canvasRender;
    RenderThread render;
    /** Creates new form AutoFrame */
    public AutoFrame() {
        initComponents();
        setBounds (100, 100, 520, 500);
        setResizable(false);
        setTitle ("Ejemplo de JPCT");
        
        Config.maxPolysVisible=20000;
        Config.farPlane=12000;
        Config.glMipmap=false;
        Config.glForceEnvMapToSecondStage=true;
        
        mundo=new World ();
        mundo.setAmbientLight (120, 120, 120);
        mundo.addLight (new SimpleVector (0, -30, 0), 20, 20, 20);
        camara=mundo.getCamera ();
        camara.setPosition (0, -8, -15);
        camara.lookAt(new SimpleVector (0, 0, 15));
        buffer=new FrameBuffer (480, 320, FrameBuffer.SAMPLINGMODE_HARDWARE_ONLY);
        buffer.disableRenderer(IRenderer.RENDERER_SOFTWARE);
        canvasRender=buffer.enableGLCanvasRenderer(IRenderer.MODE_OPENGL);
        
        mapaTeclas=new KeyMapper (canvasRender);
        this.pnl_Canvas.add (canvasRender);

        render=new RenderThread (mundo, buffer, mapaTeclas, canvasRender);
        render.OGL=true;
        render.start ();
        
        colores=new Texture [8];
        colores [0]=new Texture (render.getPath ()+"Texturas/ROJO.JPG");
        colores [1]=new Texture (render.getPath ()+"Texturas/AZUL.JPG");
        colores [2]=new Texture (render.getPath ()+"Texturas/VERDE.JPG");
        colores [3]=new Texture (render.getPath ()+"Texturas/NEGRO.JPG");
        colores [4]=new Texture (render.getPath ()+"Texturas/TOMATE.JPG");
        colores [5]=new Texture (render.getPath ()+"Texturas/AMARILLO.JPG");
        colores [6]=new Texture (render.getPath ()+"Texturas/GRIS.JPG");
        colores [7]=new Texture (render.getPath ()+"Texturas/BLANCO.JPG");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        btn_blanco = new javax.swing.JButton();
        btn_gris = new javax.swing.JButton();
        pnl_Canvas = new javax.swing.JPanel();
        btn_amarillo = new javax.swing.JButton();
        btn_negro = new javax.swing.JButton();
        btn_verde = new javax.swing.JButton();
        btn_azul = new javax.swing.JButton();
        btn_rojo = new javax.swing.JButton();
        btn_tomate = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        
        getContentPane().setLayout(null);
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        btn_blanco.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Auto/Texturas/BLANCO.JPG")));
        btn_blanco.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_blancoMouseReleased(evt);
            }
        });
        
        getContentPane().add(btn_blanco);
        btn_blanco.setBounds(380, 420, 30, 30);
        
        btn_gris.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Auto/Texturas/GRIS.JPG")));
        btn_gris.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_grisMouseReleased(evt);
            }
        });
        
        getContentPane().add(btn_gris);
        btn_gris.setBounds(340, 420, 30, 30);
        
        pnl_Canvas.setBorder(new javax.swing.border.EtchedBorder());
        getContentPane().add(pnl_Canvas);
        pnl_Canvas.setBounds(10, 70, 490, 330);
        
        btn_amarillo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Auto/Texturas/AMARILLO.JPG")));
        btn_amarillo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_amarilloMouseReleased(evt);
            }
        });
        
        getContentPane().add(btn_amarillo);
        btn_amarillo.setBounds(300, 420, 30, 30);
        
        btn_negro.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Auto/Texturas/NEGRO.JPG")));
        btn_negro.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_negroMouseReleased(evt);
            }
        });
        
        getContentPane().add(btn_negro);
        btn_negro.setBounds(220, 420, 30, 30);
        
        btn_verde.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Auto/Texturas/VERDE.JPG")));
        btn_verde.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_verdeMouseReleased(evt);
            }
        });
        
        getContentPane().add(btn_verde);
        btn_verde.setBounds(180, 420, 30, 30);
        
        btn_azul.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Auto/Texturas/AZUL.JPG")));
        btn_azul.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_azulMouseReleased(evt);
            }
        });
        
        getContentPane().add(btn_azul);
        btn_azul.setBounds(140, 420, 30, 30);
        
        btn_rojo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Auto/Texturas/ROJO.JPG")));
        btn_rojo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_rojoMouseReleased(evt);
            }
        });
        
        getContentPane().add(btn_rojo);
        btn_rojo.setBounds(100, 420, 30, 30);
        
        btn_tomate.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Auto/Texturas/TOMATE.JPG")));
        btn_tomate.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_tomateMouseReleased(evt);
            }
        });
        
        getContentPane().add(btn_tomate);
        btn_tomate.setBounds(260, 420, 30, 30);
        
        jLabel1.setFont(new java.awt.Font("Bookman Old Style", 1, 18));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Ejemplo desarrollado con Jpct usando java");
        jLabel1.setBorder(new javax.swing.border.EtchedBorder());
        getContentPane().add(jLabel1);
        jLabel1.setBounds(10, 20, 490, 40);
        
        pack();
    }//GEN-END:initComponents

    private void btn_verdeMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_verdeMouseReleased
        // Add your handling code here:
        render.texturaActual=colores [2];
        render.cambiarTextura ("Base");
        canvasRender.requestFocus();
    }//GEN-LAST:event_btn_verdeMouseReleased

    private void btn_negroMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_negroMouseReleased
        // Add your handling code here:
        render.texturaActual=colores [3];
        render.cambiarTextura ("Base");
        canvasRender.requestFocus();
    }//GEN-LAST:event_btn_negroMouseReleased

    private void btn_tomateMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_tomateMouseReleased
        // Add your handling code here:
        render.texturaActual=colores [4];
        render.cambiarTextura ("Base");
        canvasRender.requestFocus();
    }//GEN-LAST:event_btn_tomateMouseReleased

    private void btn_amarilloMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_amarilloMouseReleased
        // Add your handling code here:
        render.texturaActual=colores [5];
        render.cambiarTextura ("Base");
        canvasRender.requestFocus();
    }//GEN-LAST:event_btn_amarilloMouseReleased

    private void btn_grisMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_grisMouseReleased
        // Add your handling code here:
        render.texturaActual=colores [6];
        render.cambiarTextura ("Base");
        canvasRender.requestFocus();
    }//GEN-LAST:event_btn_grisMouseReleased

    private void btn_blancoMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_blancoMouseReleased
        // Add your handling code here:
        render.texturaActual=colores [7];
        render.cambiarTextura ("Base");
        canvasRender.requestFocus();
    }//GEN-LAST:event_btn_blancoMouseReleased

    private void btn_azulMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_azulMouseReleased
        // Add your handling code here:
        render.texturaActual=colores [1];
        render.cambiarTextura ("Base");
        canvasRender.requestFocus();
    }//GEN-LAST:event_btn_azulMouseReleased

    private void btn_rojoMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_rojoMouseReleased
        // Add your handling code here:
        render.texturaActual=colores [0];
        render.cambiarTextura ("Base");
        canvasRender.requestFocus();
    }//GEN-LAST:event_btn_rojoMouseReleased

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    	render.salir=true;
    	render.stop();
    	render=null;
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new AutoFrame().show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_blanco;
    private javax.swing.JButton btn_gris;
    private javax.swing.JPanel pnl_Canvas;
    private javax.swing.JButton btn_amarillo;
    private javax.swing.JButton btn_negro;
    private javax.swing.JButton btn_verde;
    private javax.swing.JButton btn_azul;
    private javax.swing.JButton btn_rojo;
    private javax.swing.JButton btn_tomate;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables

}
